﻿Imports Infragistics.Win

Public Class Form1

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        ugMain.DataSource = GenerateTestData()
    End Sub

    Private Function GenerateTestData() As List(Of PseutoDataRow)
        Dim returnList As New List(Of PseutoDataRow)
        Dim tmpGenerator As Random = New Random

        For rowIndex As Integer = 0 To 10
            Dim tmpFirst As Decimal = Math.Round(CDec(tmpGenerator.NextDouble * 100), 1)
            Dim tmpSecond As Decimal = Math.Round(CDec(tmpGenerator.NextDouble * 100), 1)

            returnList.Add(New PseutoDataRow(tmpFirst, tmpSecond))

        Next

        Return returnList

    End Function

    Private Sub ugMain_InitializeLayout(sender As Object, e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles ugMain.InitializeLayout

        With e.Layout.Bands(0).Columns("CombinedValue")
            .MaskInput = "nnn.n X nnn.n"
            .MaskDisplayMode = UltraWinMaskedEdit.MaskMode.IncludeLiterals
            .MaskDataMode = UltraWinMaskedEdit.MaskMode.IncludeLiteralsWithPadding
            .PromptChar = CType("", Char)

            Dim tmpEditor As EditorWithMask = TryCast(.Editor, EditorWithMask)
            If tmpEditor IsNot Nothing _
                AndAlso (tmpEditor.KeyActionMappings.GetActionMappings(Keys.X, UltraWinMaskedEdit.MaskedEditState.Character, 0) Is Nothing _
                OrElse tmpEditor.KeyActionMappings.GetActionMappings(Keys.X, UltraWinMaskedEdit.MaskedEditState.Character, 0).Count = 0) Then

                tmpEditor.KeyActionMappings.Add(New UltraWinMaskedEdit.KeyActionMapping(Keys.X, UltraWinMaskedEdit.MaskedEditAction.NextSection, 0, UltraWinMaskedEdit.MaskedEditState.Character, SpecialKeys.Ctrl, 0))
                tmpEditor.KeyActionMappings.Add(New UltraWinMaskedEdit.KeyActionMapping(Keys.X, UltraWinMaskedEdit.MaskedEditAction.AfterLastCharacter, 0, UltraWinMaskedEdit.MaskedEditState.LastSection, SpecialKeys.Ctrl, 0))
            End If

        End With

    End Sub
End Class
